<template>
  <div>
    <div class="routes-list">
      <div v-if="pending" class="routes-list__loader">
        <ob-loader
          :width="10"
          :height="10"
          :duration="2"
          class="routes-list__loader-icon"
        />
      </div>
      <ul>
        <li
          class="routes-list-item"
          v-for="route in routes"
          :key="`${route.arrival_uuid}-${route.departure_uuid}`"
        >
          <div
            class="routes-list-item-info"
            @click="showTarrifs(route.arrival_uuid, route.departure_uuid, true)"
          >
            <div
              v-if="route.arrival_uuid === arrivalUuid && route.departure_uuid === departureUuid"
            >
              <i class="icon chevron-down"></i>
            </div>
            <div v-else>
              <i class="icon chevron-up"></i>
            </div>
            <span class="departure-name">{{  locations[route.departure_uuid] ? locations[route.departure_uuid].title : '...' }}</span>
            <span>⟶</span>
            <span class="arrival-name">{{ locations[route.arrival_uuid] ? locations[route.arrival_uuid].title : '...' }}</span>
            <span class="route-distance"></span>
          </div>

          <tarrifs-table
            v-if="route.arrival_uuid === arrivalUuid && route.departure_uuid === departureUuid"
            :items="items"
            :loading="pending"
            :page-limit="page_size"
            @openModal="openModal"
            @updateFixedPrice="updateFixedPrice"
            @toggleFixedPrice="toggleFixedPrice"
          />
        </li>
      </ul>
      <div class="table-footer">
        <ObPagination
            :page="page_num - 1"
            :count="total_elements"
            :page-limit="page_size"
            @on-change="clickPage"
        />
      </div>
    </div>

    <base-price-modal
      :ref="MODALS.BASE_TARIF"
      :data="selectedRow"
      :departure-uuid="departureUuid"
      :arrival-uuid="arrivalUuid"
      @updated="showTarrifs(arrivalUuid, departureUuid)"
      v-if="currentModal === MODALS.BASE_TARIF"
      @closed="modalClosed()"
    />

    <expert-rate-modal
      :ref="MODALS.EXPERT_TARIF"
      :data="selectedRow"
      :resource-uuid="selectedRow ? selectedRow.resource_uuid : null"
      :departure-uuid="departureUuid"
      :arrival-uuid="arrivalUuid"
      @updated="showTarrifs(arrivalUuid, departureUuid)"
      v-if="currentModal === MODALS.EXPERT_TARIF"
      @closed="modalClosed()"
    />

    <ob-modal
      :ref="MODALS.AVG_TARIF"
      title="Усредненный тариф по историческим данным"
      size="large"
      custom-class="modal-medium"
      :is-show-pagination="false"
      v-if="currentModal === MODALS.AVG_TARIF"
      @updated="showTarrifs(arrivalUuid, departureUuid)"
      @closed="modalClosed()"
    >
      <average-rate-modal :data="selectedRow" />
    </ob-modal>
  </div>
</template>

<script>
import api from '@/api';

import ObModal from 'common-components/src/obComponents/obModal';
import ObPagination from 'common-components/src/obComponents/obPagination';
import ObLoader from 'common-components/src/obComponents/obLoader'

import BasePriceModal from './Modals/BasePriceModal';
import AverageRateModal from './Modals/AverateRateByHistoryDataModal';
import ExpertRateModal from './Modals/ExpertRateModal';

import TarrifsTable from './TarrifsTable';

import columns from './columns';
import {mapActions, mapGetters} from "vuex";

// TODO: move to constants. Have dublicate in TarrifsTable
const MODALS = {
  BASE_TARIF: 'baseTarif',
  EXPERT_TARIF: 'expertTarif',
  AVG_TARIF: 'avgTarif',
};

export default {
  name: 'BasePricesTable',
  components: {
    BasePriceModal,
    ObLoader,
    ObModal,
    ObPagination,
    AverageRateModal,
    ExpertRateModal,
    TarrifsTable,
  },
  props: { },
  data() {
    return {
      MODALS,
      currentModal: null,

      columns,
      items: [],
      routes: [],
      selectedRow: null,
      page_num: 1,
      page_size: 30,
      total_elements: 0,
      elements_count: 0,
      total_pages: 0,
      selectedFilter: '',
      pending: false,
      inputDepartureUuid: null,
      inputArrivalUuid: null,
      departureUuid: null,
      arrivalUuid: null,
      filterItems: [
        {
          label: 'Все',
        },
        {
          label: 'Строки с незаполненным экспертным тарифом',
        },
        {
          label: 'Строки с низким коэффициентом достоверности',
        },
        {
          label: 'Строки без коэффициента достоверности',
        },
      ],
    };
  },
  computed: {
    ...mapGetters({
      locations: 'base_prices/locations',
      services: 'base_prices/services',
    }),
  },
  methods: {
    ...mapActions({
      getLocations: 'base_prices/getLocations',
      getServices: 'base_prices/getServices',
    }),
    async updateLocations(locationPoints) {
      this.inputDepartureUuid = locationPoints.from
        ? locationPoints.from.locationUuid
        : null;
      this.inputArrivalUuid = locationPoints.to
        ? locationPoints.to.locationUuid
        : null;

      this.page_num = 1;

      this.getRoutes();
    },
    clearTable() {
      this.routes = [];
    },
    async getRoutes() {
      this.pending = true;

      try {
        const {
          content,
          elements_count,
          page_num,
          page_size,
          total_elements,
          total_pages,
        } = await api.base_prices.getRoutes(
          this.inputDepartureUuid,
          this.inputArrivalUuid,
          null,
          this.page_num,
          this.page_size
        );
        const locations = [
          this.inputDepartureUuid,
          this.inputDepartureUuid,
        ];
        content.forEach(el => {
          locations.push(el.arrival_uuid);
          locations.push(el.departure_uuid);
        });
        await this.getLocations(locations);

        this.routes = content;
        this.elements_count = elements_count;
        this.page_num = page_num;
        this.page_size = page_size;
        this.total_elements = total_elements;
        this.total_pages = total_pages;

      } catch (error) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных',
        });
      }

      this.pending = false;
    },
    async showTarrifs(arrivalUuid, departureUuid, isClick = false) {
      if (
        arrivalUuid === this.arrivalUuid &&
        departureUuid === this.departureUuid &&
        isClick
      ) {
        this.arrivalUuid = this.departureUuid = null; // to close route subtable
        return;
      }

      this.departureUuid = departureUuid;
      this.arrivalUuid = arrivalUuid;
      this.pending = true;
      try {
        const {
          content, contentWRFromTo, contentWRWithoutGeography
        } = await api.base_prices.getTariffs(
          this.departureUuid,
          this.arrivalUuid
        );

        this.items = content.reduce((all, group) => {
          const rows = group.tariffs.map(tarif => {
            const service = this.services[tarif.resource_uuid] || null;
            const groupName = service ? service.serviceTypeTitle : 'Не указано';

            return {
              ...tarif,
              service,
              group: groupName,
              type: tarif.resource_name,
              arrival_name: tarif.route.arrival_name,
              departure_name: tarif.route.departure_name,
              fixed_price: tarif.fixed_price,
              averaged_price: tarif.averaged_price,
              expert_price: tarif.expert_price,
              base_price: tarif.base_price,
              base_price_reliability: tarif.base_price_reliability,
              resource_uuid: tarif.resource_uuid,
              is_expert_price_approved: tarif.is_expert_price_approved,
              is_fixed_price_currently: tarif.is_fixed_price_currently,
            };
          });

          return [...all, ...rows];
        }, []);

        let contentWRWhereRows = this.processWRData(contentWRFromTo,'Услуги без ресурса (Откуда/Куда)');
        let contentWRWithoutGeograhyRows = this.processWRData(contentWRWithoutGeography,'Услуги без ресурса (Без привязки к географии)');
        this.items = this.items.concat(contentWRWhereRows, contentWRWithoutGeograhyRows);
      } catch (error) {
        console.error(error);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных',
        });
      }

      this.pending = false;
    },
    processWRData(data, groupName) {
      if(data && data.length) {
        return data.reduce((all, tarif) => {
          const service = this.services[tarif.serviceUuid] || null;
          if (service) {
            if (tarif.fixedPrice) {
              tarif.fixed_price = {
                distance: tarif.fixedPrice.distance,
                price_km: tarif.fixedPrice.priceKm,
                price_stage: tarif.fixedPrice.priceStage,
              }
            }
            if (tarif.basePrice) {
              tarif.base_price = {
                distance: tarif.basePrice.distance,
                price_km: tarif.basePrice.priceKm,
                price_stage: tarif.basePrice.priceStage,
              }
            }
            tarif =  {
              ...tarif,
              service,
              group: groupName,
              type: service.serviceTypeTitle,
              arrival_name: this.locations[this.arrivalUuid]?.title ?? '...',
              departure_name: this.locations[this.departureUuid]?.title ?? '...',
              resource_uuid: tarif.serviceUuid,
              is_expert_price_approved: true,
              is_fixed_price_currently: tarif.isFixedPriceCurrently,
              route: {
                arrival_name: this.locations[this.arrivalUuid]?.title ?? '...',
                arrival_uuid: this.arrivalUuid,
                departure_name: this.locations[this.departureUuid]?.title ?? '...',
                departure_uuid: this.departureUuid,
              },
              isWR: true,
            };
            return [...all, tarif];
          } else {
            return [...all];
          }
        }, []);
      }
      return [];
    },
    clickPage(page) {
      this.page_num = page + 1;
      this.getRoutes();
    },
    openModal(modal, data) {
      this.currentModal = modal;
      this.selectedRow = {
        ...data,
        arrivalLocation: this.locations[data.route.arrival_uuid] || null,
        departureLocation: this.locations[data.route.departure_uuid] || null,
      };

      this.$nextTick(() => this.$refs[this.currentModal].open());
    },
    modalClosed() {
      this.$nextTick(() => {
        setTimeout(() => {
          this.currentModal = null;
        }, 300);
      });
    },
    isReliable(item) {
      return item && item.persentage >= 75;
    },
    async updateFixedPrice(value, data){
      let notificationId = new Date().getTime() + 'save';
      try{
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId,
        });

        const {departure_uuid, arrival_uuid} = data.data.item.route;
        const {resource_uuid} = data.data.item;

        let distance = data.data.item?.fixed_price?.distance;
        if(data.data.item.isWR) {
          distance = 1;
        }
        if(!distance){
          const distanceResponse = await api.base_prices.getExtrapolationDistance(
            departure_uuid,
            arrival_uuid,
            resource_uuid
          );
          distance = distanceResponse.distance
        }

        if(!distance){
          const obj = {
            ...data.data.item,
            fixed_price: {
              price_km: +(+String(+value.replace(/ /g, '').replace(/,/g, '.') / +1)).toFixed(2).replace(/\./g, ''),
              distance: 1,
              fixedPriceIsEdit: true,
            },
          };
          this.openModal('baseTarif', obj);
          return;
        }
        const price_stage = (+String(+value.replace(/ /g, '').replace(/,/g, '.'))).toFixed(2).replace(/\./g, '');

        await api.base_prices.updateFixedPrice(
          departure_uuid,
          arrival_uuid,
          resource_uuid,
          {
            price_stage,
            distance,
          }
        );
        this.showTarrifs( arrival_uuid, departure_uuid);
        this.$notification({
          type: 'system_notification_success',
          message: `Сохранено`,
        });

      } catch {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных',
        });
      } finally {
        this.$notification({ event: 'close', id: notificationId });
      }
    },
    async toggleFixedPrice(data){
      let notificationId = new Date().getTime() + 'save';
      try {
        const departure_uuid = data.route.departure_uuid;
        const arrival_uuid = data.route.arrival_uuid;
        const resource_uuid = data.resource_uuid;

        if(data.fixed_price && !data.is_fixed_price_currently){
          await api.base_prices.updateFixedPrice(
            departure_uuid,
            arrival_uuid,
            resource_uuid,
            {
              price_stage: data.fixed_price.price_stage,
              distance: data.fixed_price.distance,
            }
          );
          this.showTarrifs( arrival_uuid, departure_uuid);
          return;
        }

        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId,
        });

        await api.base_prices.deleteFixedPrice(
          departure_uuid,
          arrival_uuid,
          resource_uuid
        );
        this.$notification({
          type: 'system_notification_success',
          message: `Сохранено`,
        });
        this.showTarrifs( arrival_uuid, departure_uuid);

      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено',
        });
      }finally {
        this.$notification({ event: 'close', id: notificationId });
      }
    }
  },
};
</script>

<style lang="scss" scoped>
$cobalt-background: #f2f7fd;
$cobalt-border: #d3e1f1;
$cobalt-blue: #0242ad;
$cobalt: #004bc8;
$cobalt-black: #191e32;
$shale-gray: #474b5b;
$gray-slate: #737682;
$gray-light: #9da0ac;

@import '~common-components/src/static/css/mixins';

.page-controls {
  position: absolute;
  right: 0;
  margin: -40px 35px 0 20px;
  display: flex;
  align-items: center;
  button {
    @include font-mixin(12px, 16px, 500, $cobalt, 1.6px);
    text-transform: uppercase;
  }
}

.show-items {
  align-self: center;
  margin-right: auto;
  margin-left: 30px;
  display: flex;
  flex-direction: row;
  padding: 5px 9px;
  height: 28px;
  background: #e5edf9;
  border-radius: 19px;
  .filter-items {
    span {
      margin-left: 20px;
    }
  }
  &-label {
    margin-right: 10px;
    color: $gray-slate;
  }
}
.routes-list {
  position: relative;

  ul {
    list-style-type: none;
  }
  &-item {
    border-bottom: 1px solid #e5edf9;
    &-info {
      cursor: pointer;
      display: flex;
      background: $cobalt-background;
      color: #0070a6;
      padding: 14px 14px;
      //  border-bottom: 1px solid $cobalt-border;
      span {
        margin: 0 15px;
      }
      i {
        font-size: 16px;
      }
    }
  }
  &__loader {
    position: absolute;
    background: $background-white;
    opacity: 0.8;
    left: 0;
    bottom: 0;
    width: 100%;
    height: 100%;
    &-icon {
      position: absolute;
      top: calc(50% - 20px);
      left: calc(50% - 20px);
      width: 40px;
      height: 40px;
    }
  }
}

.mb20 {
  margin-bottom: 20px;
}
.mb40 {
  margin-bottom: 40px;
}
.wdt50 {
  width: 50%;
}
.td-container {
  position: relative;
}
::v-deep {
  .bordered {
    border: 1px solid #ffb137;
    height: 60px;
    display: flex;
    justify-content: flex-end;
    align-items: center;
  }
  .empty-cell {
    height: 60px;
    padding: 8px 14px;
    display: flex;
    justify-content: flex-end;
    align-items: center;
  }
  .td-container {
    margin: -1px 0;
    padding-left: 0 !important;
    padding-right: 0 !important;
    .fixed,
    .avg,
    .base,
    .expert,
    .trust {
      margin: -8px 0;
      width: 100%;
      text-align: right;
      border-right: 1px solid #e5edf9;
      border-left: 1px solid #e5edf9;
    }
  }
  thead .td-container {
    padding: 8px 14px !important;
  }
  .flexbox {
    display: flex;
    align-items: center;
    justify-content: flex-start;

    &.empty-expert-price {
      position: relative;
      &:before {
        content: '';
        position: absolute;
        top: -16px;
        left: 0;
        border: 8px solid transparent;
        border-left: 8px solid #ffb137;
        border-top: 8px solid #ffb137;
        display: block;
        width: 0;
        height: 0;
      }
    }
    .icon {
      margin-right: 30px;
      margin-left: 50px;
    }
  }
  .fixed-tarif,
  .expert-tarif,
  .avg-tarif,
  .base-tarif,
  .trust-tarif {
    padding: 0 14px;
    height: 60px;
    display: flex;
    justify-content: flex-end;
    flex-wrap: wrap;
    align-items: center;
  }

  // .fixed-tarif,
  // .trust-tarif
  .expert-tarif,
  .avg-tarif,
  .base-tarif {
    cursor: pointer;
  }

  .fixed-tarif .price-locked {
    font-size: 25px;
    color: #e62d3b;
    position: absolute;
    left: 15%;
  }
  .fixed-tarif .price-unlocked{
    color: #dedede;
  }

  .null-cell {
    color: $gray-light;
  }
  .cell-icon {
    .icon {
      margin-left: auto;
      margin-right: 10px;
    }
  }
  .cell-value {
    @include font-mixin(16px, 20px, 400, $cobalt-black, 0.2px);
    width: 100%;
    height: 30px;
    line-height: 45px;
    &.disabled {
      color: $gray-light;
    }
  }
  .cell-label {
    color: #9da0ac;
    @include font-mixin(10px, 16px, 400, $gray-light, 0.2px);
    display: flex;
    justify-content: space-between;
    text-transform: uppercase;
    height: 30px;
  }
  .currency {
    @include font-mixin(10px, 16px, 500, $gray-light, 0.2px);
    text-transform: uppercase;
    margin-right: 5px;
  }
  .reliability {
    cursor: default;
    font-size: 16px;
    &-high {
      color: #0fb785;
    }
    &-low {
      color: #e62d3b;
    }
  }
  .progress-cell {
    display: flex;
    justify-content: flex-start;
    width: 32px;
    position: relative;
    border-radius: 2px;
    box-shadow: inset 0px 1px 2px rgba(0, 75, 200, 0.2);
    background: rgba(196, 213, 237, 0.5);
    .bar {
      height: 8px;
      &-filled {
        border-radius: 2px 0 0 2px;
        background: #10cf96;
      }
    }
    .value {
      position: absolute;
      right: 5px;
      height: 14px;
      top: -3px;
      opacity: 0.4;
      width: 1px;
      background: #99b7e9;
    }
  }
  .item-to-show {
    @include font-mixin(16px, 22px, 400, $cobalt-black, 0.2px);
    cursor: pointer;
  }
}
</style>
